<?php namespace App\Controllers\Tarifas;


use App\Entities\Tarifas\TarifaextraEntity;

class Tarifaextra extends \App\Controllers\GoBaseController
{

    use \CodeIgniter\API\ResponseTrait;

    protected static $primaryModelName = 'App\Models\Tarifas\TarifaextraModel';

    protected static $singularObjectNameCc = 'tarifaextra';
    protected static $singularObjectName = 'Tarifaextra';
    protected static $pluralObjectName = 'Tarifasextra';
    protected static $controllerSlug = 'tarifaextra';

    protected static $viewPath = 'themes/vuexy/form/tarifas/extra/';

    protected $indexRoute = 'tarifaextraList';


    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        $this->viewData['pageTitle'] = lang('Tarifaextra.moduleTitle');
        // Se indica que este controlador trabaja con soft_delete
        $this->soft_delete = true;
        // Se indica el flag para los ficheros borrados
        $this->delete_flag = 1;

        // Breadcrumbs
        $this->viewData['breadcrumb'] = [
            ['title' => lang("App.menu_tarifas"), 'route' => "javascript:void(0);", 'active' => false],
            ['title' => lang("App.menu_tarifaextra"), 'route' => site_url('tarifas/tarifaextra'), 'active' => true]
        ];

        parent::initController($request, $response, $logger);

    }

    public function index()
    {
        checkPermission('tarifa-extra.menu');

        $this->viewData['usingClientSideDataTable'] = true;

        $this->viewData['pageSubTitle'] = lang('Basic.global.ManageAllRecords', [lang('Tarifaextra.tarifaextra')]);
        parent::index();

    }

    public function add()
    {

        checkPermission('tarifa-extra.create', $this->indexRoute);

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();
            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);


            if ($this->request->getPost('mostrar_en_presupuesto') == null) {
                $sanitizedData['mostrar_en_presupuesto'] = false;
            }
            if ($this->request->getPost('mostrar_en_presupuesto_cliente') == null) {
                $sanitizedData['mostrar_en_presupuesto_cliente'] = false;
            }
            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()) :
                    try {
                        $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;
            if ($noException && $successfulResult) :

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('successMessage', $message);
                    else:
                        return $this->redirect2listView('successMessage', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaextraEntity'] = isset($sanitizedData) ? new TarifaextraEntity($sanitizedData) : new TarifaextraEntity();

        $this->viewData['formAction'] = route_to('createTarifaextra');

        $this->viewData['boxTitle'] = lang('Basic.global.addNew') . ' ' . lang('Tarifaextra.tarifaextra') . ' ' . lang('Basic.global.addNewSuffix');


        return $this->displayForm(__METHOD__);
    } // end function add()

    public function edit($requestedId = null)
    {

        checkPermission('tarifa-extra.edit', $this->indexRoute);

        if ($requestedId == null) :
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $tarifaextraEntity = $this->model->find($id);

        if ($tarifaextraEntity == false) :
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('Tarifaextra.tarifaextra')), $id]);
            return $this->redirect2listView('errorMessage', $message);
        endif;

        if ($this->request->getPost()) :

            $postData = $this->request->getPost();
            $sanitizedData = $this->sanitized($postData, true);

            // JJO
            if (isset($this->model->user_updated_id)) {
                $sanitizedData['user_updated_id'] = auth()->user()->id;
            }
            if ($this->request->getPost('mostrar_en_presupuesto') == null) {
                $sanitizedData['mostrar_en_presupuesto'] = false;
            }
            if ($this->request->getPost('mostrar_en_presupuesto_cliente') == null) {
                $sanitizedData['mostrar_en_presupuesto_cliente'] = false;
            }
            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :
                if ($this->canValidate()) :
                    try {
                        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('Tarifaextra.tarifaextra'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $tarifaextraEntity->fill($sanitizedData);

                $thenRedirect = false;
            endif;
            if ($noException && $successfulResult) :
                $id = $tarifaextraEntity->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('successMessage', $message);
                    else:
                        return $this->redirect2listView('successMessage', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaextraEntity'] = $tarifaextraEntity;

        $this->viewData['formAction'] = route_to('updateTarifaextra', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2') . ' ' . lang('Tarifaextra.tarifaextra') . ' ' . lang('Basic.global.edit3');


        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)

    public function allItemsSelect()
    {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal . ', nombre', 'nombre', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->nombre = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems()
    {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'nombre'];
            $onlyActiveOnes = false;
            $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->text = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function getSelect2()
    {
        if ($this->request->isAJAX()) {
            $query = $this->model->builder()->select(
                [
                    "id",
                    "nombre as name"
                ]
            )->where("deleted_at", null)
            ->where("mostrar_en_presupuesto", 1);
            if ($this->request->getGet("q")) {
                $query->groupStart()
                    ->orLike("tarifa_extra.nombre", $this->request->getGet("q"))
                    ->groupEnd();
            }

            return $this->response->setJSON($query->get()->getResultObject());
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }
}
